<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: *");

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;

class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	//if (!function_exists('getallheaders')) {
		private function getallheaders() {
	    	$headers = [];
	    	//var_dump($_SERVER);
	    	foreach ($_SERVER as $name => $value) {
	        	if (substr($name, 0, 5) == 'HTTP_') {
	            	$headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
	        	}
	    	}
	    	//var_dump($headers);

	    	return $headers;
	    }
	//}

		private function get_nginx_headers($function_name='getallheaders'){

	        $all_headers=array();

	        if(function_exists($function_name)){ 

	            $all_headers=$function_name();
	        }
	        else{

	            foreach($_SERVER as $name => $value){

	                if(substr($name,0,5)=='HTTP_'){

	                    $name=substr($name,5);
	                    $name=str_replace('_',' ',$name);
	                    $name=strtolower($name);
	                    $name=ucwords($name);
	                    $name=str_replace(' ', '-', $name);

	                    $all_headers[$name] = $value; 
	                }
	                elseif($function_name=='apache_request_headers'){

	                    $all_headers[$name] = $value; 
	                }
	            }
	        }


	        return $all_headers;
	}
	
	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed.","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);

		
		if(isset($data['user_id']) && $data['user_id']!='' && isset($data['sessionkey']) && $data['sessionkey']!=''){	
			$this->load->model('Authenticationcheck');
			$checkSessionKey = $this->Authenticationcheck->validateSessionKey($data['sessionkey'],$data['user_id']);

			if($checkSessionKey==true){

				$user_id = (isset($data['user_id']) && $data['user_id']!='') ? $data['user_id'] : 0;
				$session_key = (isset($data['sessionkey']) && $data['sessionkey']!='') ? $data['sessionkey'] : '';

				$email = (isset($data['email']) && $data['email']!='') ? $data['email'] : '';
				$name = (isset($data['name']) && $data['name']!='') ? $data['name'] : '';
				$phone = (isset($data['phone']) && $data['phone']!='') ? $data['phone'] : '';

				
				$posted_on = date('Y-m-d H:i:s');
				$row_status = 'ACTIVE';

				$dataMasterArr = array(
							'user_id' => $user_id,
							'session_key' => $session_key,
							'name' => $name,
							'email' => $email,
							'phone' => $phone,
							'posted_on' => $posted_on,
							'row_status' => $row_status
						);
				$this->load->model('Bulkorder_model');
				$xx = $this->Bulkorder_model->insertBulkOrderMaster($dataMasterArr);
				if($xx!=false && $xx>0){
					// Order Details
					if(isset($data['products']) && count($data['products'])>0){
						foreach ($data['products'] as $bkey => $bvalue) {
							$bulk_order_master_id = $xx;
							$product_id = (isset($bvalue['productId']) && $bvalue['productId']!='') ? $bvalue['productId'] : 0;
							$quantity = (isset($bvalue['quantity']) && $bvalue['quantity']!='') ? $bvalue['quantity'] : 0;
							$discount = (isset($bvalue['unit']['discount']) && $bvalue['unit']['discount']!='') ? $bvalue['unit']['discount'] : 0;
							$final_price = (isset($bvalue['unit']['final_price']) && $bvalue['unit']['final_price']!='') ? $bvalue['unit']['final_price'] : 0;
							$mrp = (isset($bvalue['unit']['mrp']) && $bvalue['unit']['mrp']!='') ? $bvalue['unit']['mrp'] : 0;
							$product_price_id = (isset($bvalue['unit']['product_price_id']) && $bvalue['unit']['product_price_id']!='') ? $bvalue['unit']['product_price_id'] : 0;
							$qty = (isset($bvalue['unit']['qty']) && $bvalue['unit']['qty']!='') ? $bvalue['unit']['qty'] : 0;
							$unit_id = (isset($bvalue['unit']['unit_id']) && $bvalue['unit']['unit_id']!='') ? $bvalue['unit']['unit_id'] : 0;
							$unit_name = (isset($bvalue['unit']['unit_name']) && $bvalue['unit']['unit_name']!='') ? $bvalue['unit']['unit_name'] : '';
							$posted_on = $posted_on;
							$row_status = $row_status;
							$order_status = 'PENDING';

							$dataDetailsArr = array(
													'bulk_order_master_id' => $bulk_order_master_id,
													'product_id' => $product_id,
													'quantity' => $quantity,
													'discount' => $discount,
													'final_price' => $final_price,
													'mrp' => $mrp,
													'product_price_id' => $product_price_id,
													'qty' => $qty,
													'unit_id' => $unit_id,
													'unit_name' => $unit_name,
													'posted_on' => $posted_on,
													'row_status' => $row_status,
													'order_status' => $order_status
												);
							$this->Bulkorder_model->insertBulkOrderDetails($dataDetailsArr);
						}
					}
					$this->response(array('status'=>true,"message"=>"Bulk Order send successfully!","code"=>200,"data"=>null), REST_Controller::HTTP_OK);
				}else{
					$this->response(array('status'=>false,"message"=>"Failed to add the product to cart.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
				}		
			}else{
				$this->response(array('status'=>false,"message"=>"Session Key Mismatch.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
			}
		}else{
			$this->response(array('status'=>false,"message"=>"Requested Dataset Missing.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
		}		
		
	}				
}
?>