<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: *");

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;

class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	//if (!function_exists('getallheaders')) {
		private function getallheaders() {
	    	$headers = [];
	    	//var_dump($_SERVER);
	    	foreach ($_SERVER as $name => $value) {
	        	if (substr($name, 0, 5) == 'HTTP_') {
	            	$headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
	        	}
	    	}
	    	//var_dump($headers);

	    	return $headers;
	    }
	//}

		private function get_nginx_headers($function_name='getallheaders'){

	        $all_headers=array();

	        if(function_exists($function_name)){ 

	            $all_headers=$function_name();
	        }
	        else{

	            foreach($_SERVER as $name => $value){

	                if(substr($name,0,5)=='HTTP_'){

	                    $name=substr($name,5);
	                    $name=str_replace('_',' ',$name);
	                    $name=strtolower($name);
	                    $name=ucwords($name);
	                    $name=str_replace(' ', '-', $name);

	                    $all_headers[$name] = $value; 
	                }
	                elseif($function_name=='apache_request_headers'){

	                    $all_headers[$name] = $value; 
	                }
	            }
	        }


	        return $all_headers;
	}
	
	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed.","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);

		
		if(isset($data['product_id']) && $data['product_id']!='' && isset($data['user_id']) && $data['user_id']!='' && isset($data['sessionkey']) && $data['sessionkey']!=''){	
			$this->load->model('Authenticationcheck');
			$checkSessionKey = $this->Authenticationcheck->validateSessionKey($data['sessionkey'],$data['user_id']);

			if($checkSessionKey==true){

				$user_id = (isset($data['user_id']) && $data['user_id']!='') ? $data['user_id'] : 0;
				$session_key = (isset($data['sessionkey']) && $data['sessionkey']!='') ? $data['sessionkey'] : '';
				$product_id = (isset($data['product_id']) && $data['product_id']!='') ? $data['product_id'] : 0;
				$qty = (isset($data['qty']) && $data['qty']!='') ? $data['qty'] : 0;
				$per_mrp_price = (isset($data['per_mrp_price']) && $data['per_mrp_price']!='') ? $data['per_mrp_price'] : 0;
				$total_mrp_price = (isset($data['total_mrp_price']) && $data['total_mrp_price']!='') ? $data['total_mrp_price'] : 0;
				$per_discount = (isset($data['per_discount']) && $data['per_discount']!='') ? $data['per_discount'] : 0;
				$total_discount = (isset($data['total_discount']) && $data['total_discount']!='') ? $data['total_discount'] : 0;
				$final_per_price = (isset($data['final_per_price']) && $data['final_per_price']!='') ? $data['final_per_price'] : 0;
				$final_total_price = (isset($data['final_total_price']) && $data['final_total_price']!='') ? $data['final_total_price'] : 0;
				$product_price_id = (isset($data['product_price_id']) && $data['product_price_id']!='') ? $data['product_price_id'] : 0;
				$price_qty = (isset($data['price_qty']) && $data['price_qty']!='') ? $data['price_qty'] : 0;
				$price_unit_name = (isset($data['price_unit_name']) && $data['price_unit_name']!='') ? $data['price_unit_name'] : '';

				$posted_on = date('Y-m-d H:i:s');
				$status = 'ACTIVE';

				$this->load->model('Cart_model');
				$cartArr = $this->Cart_model->getSameProductCartList($user_id,$product_id,$product_price_id,$price_qty,$price_unit_name);
				if(isset($cartArr) && count($cartArr)){

					$cartId = (isset($cartArr[0]['id']) && $cartArr[0]['id']!='') ? $cartArr[0]['id'] : 0;

					$qty = (isset($cartArr[0]['qty']) && $cartArr[0]['qty']!='') ? ($cartArr[0]['qty'] + $qty) : $qty;
					$total_mrp_price = ($per_mrp_price * $qty);
					$total_discount = ($per_discount * $qty);
					$final_total_price = ($final_per_price * $qty);

					$dataArr = array(
								'user_id' => $user_id,
								'session_key' => $session_key,
								'product_id' => $product_id,
								'product_price_id' => $product_price_id,
								'price_qty' => $price_qty,
								'price_unit_name' => $price_unit_name,
								'qty' => $qty,
								'per_mrp_price' => $per_mrp_price,
								'total_mrp_price' => $total_mrp_price,
								'per_discount' => $per_discount,
								'total_discount' => $total_discount,
								'final_per_price' => $final_per_price,
								'final_total_price' => $final_total_price,
								'last_modified_on' => $posted_on
							);
					$xx = $this->Cart_model->updateCart($cartId,$dataArr);
					if($xx==true){
						$this->response(array('status'=>true,"message"=>"Product added to cart successfully!","code"=>200,"data"=>null), REST_Controller::HTTP_OK);
					}else{
						$this->response(array('status'=>false,"message"=>"Failed to add the product to cart.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
					}
				}else{

					$dataArr = array(
								'user_id' => $user_id,
								'session_key' => $session_key,
								'product_id' => $product_id,
								'product_price_id' => $product_price_id,
								'price_qty' => $price_qty,
								'price_unit_name' => $price_unit_name,
								'qty' => $qty,
								'per_mrp_price' => $per_mrp_price,
								'total_mrp_price' => $total_mrp_price,
								'per_discount' => $per_discount,
								'total_discount' => $total_discount,
								'final_per_price' => $final_per_price,
								'final_total_price' => $final_total_price,
								'posted_on' => $posted_on,
								'status' => $status
							);

					$xx = $this->Cart_model->insertCart($dataArr);
					if($xx!=false && $xx>0){
						$this->response(array('status'=>true,"message"=>"Product added to cart successfully!","code"=>200,"data"=>null), REST_Controller::HTTP_OK);
					}else{
						$this->response(array('status'=>false,"message"=>"Failed to add the product to cart.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
					}
				}		
			}else{
				$this->response(array('status'=>false,"message"=>"Session Key Mismatch.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
			}
		}else{
			$this->response(array('status'=>false,"message"=>"Requested Dataset Missing.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
		}		
		
	}				
}
?>