<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: *");

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;

class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	//if (!function_exists('getallheaders')) {
		private function getallheaders() {
	    	$headers = [];
	    	//var_dump($_SERVER);
	    	foreach ($_SERVER as $name => $value) {
	        	if (substr($name, 0, 5) == 'HTTP_') {
	            	$headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
	        	}
	    	}
	    	//var_dump($headers);

	    	return $headers;
	    }
	//}

		private function get_nginx_headers($function_name='getallheaders'){

	        $all_headers=array();

	        if(function_exists($function_name)){ 

	            $all_headers=$function_name();
	        }
	        else{

	            foreach($_SERVER as $name => $value){

	                if(substr($name,0,5)=='HTTP_'){

	                    $name=substr($name,5);
	                    $name=str_replace('_',' ',$name);
	                    $name=strtolower($name);
	                    $name=ucwords($name);
	                    $name=str_replace(' ', '-', $name);

	                    $all_headers[$name] = $value; 
	                }
	                elseif($function_name=='apache_request_headers'){

	                    $all_headers[$name] = $value; 
	                }
	            }
	        }


	        return $all_headers;
	}
	
	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed.","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);

		
		if(isset($data['user_id']) && $data['user_id']!='' && isset($data['sessionkey']) && $data['sessionkey']!=''){

			$this->load->model('Authenticationcheck');
			$checkSessionKey = $this->Authenticationcheck->validateSessionKey($data['sessionkey'],$data['user_id']);
			if($checkSessionKey==true){	

				$user_id = (isset($data['user_id']) && $data['user_id']!='') ? $data['user_id'] : 0;
				$session_key = (isset($data['sessionkey']) && $data['sessionkey']!='') ? $data['sessionkey'] : '';
				$limit = (isset($data['limit']) && $data['limit']!='') ? $data['limit'] : null;

				$this->load->model('Cart_model');
				$this->load->model('Products_model');
				$cartArr = $this->Cart_model->getMyCartList($user_id,$limit);

				$resultArr = array();
				if(isset($cartArr) && count($cartArr)>0){
					foreach ($cartArr as $ckey => $cvalue) {
						
						$pImageArr = $this->Products_model->getProductImage($cvalue['product_id']);
						$pimage = '';
						if(isset($pImageArr[0]['image']) && $pImageArr[0]['image']!=''){
							$pimage = 'https://liebigs.hitechanimation.com/backend/assets/productimages/'.$pImageArr[0]['image'];
						}
						$cArr = array(
									'cart_id' => $cvalue['id'],
									'product_id' => $cvalue['product_id'],
									'product_price_id' => $cvalue['product_price_id'],
									'price_qty' => round($cvalue['price_qty']),
									'price_unit_name' => $cvalue['price_unit_name'],
									'qty' => $cvalue['qty'],
									'per_mrp_price' => $cvalue['per_mrp_price'],
									'total_mrp_price' => $cvalue['total_mrp_price'],
									'per_discount' => $cvalue['per_discount'],
									'total_discount' => $cvalue['total_discount'],
									'final_per_price' => $cvalue['final_per_price'],
									'final_total_price' => $cvalue['final_total_price'],
									'posted_on' => $cvalue['posted_on'],
									'product_code' => $cvalue['product_code'],
									'product_name' => $cvalue['product_name'],
									//'product_price' => $cvalue['product_price'],
									//'discount_price' => $cvalue['discount_price'],
									'sku_number' => $cvalue['sku_number'],
									'product_description' => $cvalue['product_description'],
									'in_stock' => $cvalue['in_stock'],
									'image' => $pimage,
								);
						$resultArr[] = $cArr;
							
					}
				}

				if(isset($resultArr) && $resultArr>0){

					$this->response(array("status"=>true,"message"=>"successfully load cart list","data"=>$resultArr,"code"=>200),REST_Controller::HTTP_OK);

				}else{
					$this->response(array('status'=>false,"message"=>"Something Wrong, Please contact to system admin.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);	
				}		
			}else{
				$this->response(array('status'=>false,"message"=>"Session Key Mismatch.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
			}
		}else{
			$this->response(array('status'=>false,"message"=>"Requested Dataset Missing.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
		}		
		
	}				
}
?>