<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;

class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);


		if(isset($data['email']) && $data['email']!='' && isset($data['password']) && $data['password']!=''){


			$this->load->model('Authenticationcheck');
			$xx = $this->Authenticationcheck->validateLogin($data['email'],$data['password']);

			//if(count($xx)>0){
            if(is_object($xx)){
                
				//////////////
				
				$user_id = $xx->id;
				$session_key = $session_key = bin2hex(openssl_random_pseudo_bytes(22));
				//bin2hex(mcrypt_create_iv(22, MCRYPT_DEV_URANDOM));
				$login_time = date('Y-m-d H:i:s');
				$logout_time = '0000-00-00 00:00:00';
				$user_ip = '';
				$device_id = isset($data['device_id']) ? $data['device_id'] : '';
				$status = 'ACTIVE';

				$updateD =  $this->Authenticationcheck->updateLoginLogs($user_id);

				$insertId = $this->Authenticationcheck->insertLoginLogs($user_id,$session_key,$login_time,$logout_time,$user_ip,$device_id,$status);


				if($insertId>0){

					//$userlogo = (isset($xx->logoname) && $xx->logoname!='') ? 'https://ceebeedesignstudio.com/ceebeecms/assets/userlogo/'.$xx->logoname : 'https://ceebeedesignstudio.com/ceebeecms/assets/userlogo/default.jpg';
					$userlogo = '';
					
					$data123 = array(
						'userid' => $xx->id,
	             		'fullname' => $xx->fullname,
	             		'email' => $xx->email,
	             		'phonenumber' => $xx->phonenumber,
	             		'userlogo' => $userlogo,
	             		'session_key' => $session_key,
	             		'is_logged_in'=>1
	             	);

					$this->response(array("status"=>true,"message"=>"Successfully Logged in","data"=>$data123,"code"=>200),REST_Controller::HTTP_OK);
				}else{
					$this->response(array('status'=>false,"message"=>"Something wrong, Please contact to system admin.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
				}

            }else{
             	$this->response(array('status'=>false,"message"=>"Enter Valid Email Or Password..","code"=>402,"data"=>null), REST_Controller::HTTP_OK);
            }

		}else{

			$this->response(array('status'=>false,"message"=>"Email or Password Not Found.","code"=>404,"data"=>null), REST_Controller::HTTP_OK);
		}
		
	}				
}
?>