<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: *");

// use namespace
use Restserver\Libraries\REST_Controller;

class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	//if (!function_exists('getallheaders')) {
		private function getallheaders() {
	    	$headers = [];
	    	//var_dump($_SERVER);
	    	foreach ($_SERVER as $name => $value) {
	        	if (substr($name, 0, 5) == 'HTTP_') {
	            	$headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
	        	}
	    	}
	    	//var_dump($headers);

	    	return $headers;
	    }
	//}

		private function get_nginx_headers($function_name='getallheaders'){

	        $all_headers=array();

	        if(function_exists($function_name)){ 

	            $all_headers=$function_name();
	        }
	        else{

	            foreach($_SERVER as $name => $value){

	                if(substr($name,0,5)=='HTTP_'){

	                    $name=substr($name,5);
	                    $name=str_replace('_',' ',$name);
	                    $name=strtolower($name);
	                    $name=ucwords($name);
	                    $name=str_replace(' ', '-', $name);

	                    $all_headers[$name] = $value; 
	                }
	                elseif($function_name=='apache_request_headers'){

	                    $all_headers[$name] = $value; 
	                }
	            }
	        }


	        return $all_headers;
	}

	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);

		$session_key1 = isset($this->getallheaders()['session_key']) ? $this->getallheaders()['session_key'] : '';

		$session_key2 = isset($this->getallheaders()['Session_key']) ? $this->getallheaders()['Session_key'] : '';

		$session_key3 = isset($this->get_nginx_headers()['sessionkey']) ? $this->get_nginx_headers()['sessionkey'] : '';

		$session_key4 = isset($this->get_nginx_headers()['Sessionkey']) ? $this->get_nginx_headers()['Sessionkey'] : '';

		//$session_key = ((isset($session_key1) && $session_key1!='') ? $session_key1 : ((isset($session_key2) && $session_key2!='') ? $session_key2 : ''));
		$session_key = '';
		if(isset($session_key1) && $session_key1!=''){
			$session_key = $session_key1;
		}else if(isset($session_key2) && $session_key2!=''){
			$session_key = $session_key2;
		}else if(isset($session_key3) && $session_key3!=''){
			$session_key = $session_key3;
		}else if(isset($session_key4) && $session_key4!=''){
			$session_key = $session_key4;
		}

		if(isset($session_key) && $session_key!=''){

			if(isset($data['user_id']) && $data['user_id']!='' && isset($data['sessionkey']) && $data['sessionkey']!=''){

				$this->load->model('Authenticationcheck');
				$checkSessionKey = $this->Authenticationcheck->validateSessionKey($data['sessionkey'],$data['user_id']);

				if($checkSessionKey==true){

					$logoutD = $this->Authenticationcheck->updateLoginLogs($data['user_id'],$data['sessionkey']);

					$this->response(array("status"=>true,"message"=>"Successfully Logged out","data"=>null,"code"=>200),REST_Controller::HTTP_OK);

				}else{

					$this->response(array('status'=>false,"message"=>"Session Key Mismatch.","code"=>401,"data"=>array('s'=>$data['sessionkey'],'u'=>$data['user_id'])), REST_Controller::HTTP_OK);
				}
			}else{
				$this->response(array('status'=>false,"message"=>"Requested Dataset Missing.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
			}
		}else{
			$this->response(array('status'=>false,"message"=>"Session Key Missing.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
		}
		
	}				
}
?>