<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: *");
// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;



class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);


		if(isset($data['cart_id']) && count($data['cart_id'])>0 && isset($data['user_id']) && $data['user_id']!='' && isset($data['total_amount']) && $data['total_amount']!=''){


			$this->load->model('Authenticationcheck');
			$checkSessionKey = $this->Authenticationcheck->validateSessionKey($data['sessionkey'],$data['user_id']);

			//if(count($xx)>0){
            if($checkSessionKey==true){
                
                // Create the payment request using the Instamojo API

                // Animesh cred
                $API_KEY = 'test_fca9afe2bd95aca4e381b6404f9';
				$AUTH_TOKEN = 'test_67dc70700add115b3a17b6207fb';
		        $instamojoEndpoint = 'https://test.instamojo.com/api/1.1/payment-requests/';

                // production
                // $API_KEY = '2707f56c691b2ee1cfb78dadbbc9dcf1';
                // $AUTH_TOKEN = 'd05ae359cd1dc5dcd9b14958c70df612';
                // $instamojoEndpoint = 'https://www.instamojo.com/api/1.1/payment-requests/';
                
		        $payload = array(
		            'purpose' => 'Order Payment',
		            'amount' => $data['total_amount'],
		            'buyer_name' => $data['first_name'],
		            'email' => $data['email'],
		            'phone' => $data['phone'],
		            'send_email' => true,
		            'redirect_url' => 'https://liebigs.hitechanimation.com/payment-status',
		            //'webhook' => 'YOUR_WEBHOOK_URL',
		        );
                
		        $headers = array(
                    'X-Api-Key:'.$API_KEY,
                    'X-Auth-Token:'.$AUTH_TOKEN
                );

                // for poduction
                // $headers = array(
                //     'Authorization' => 'Basic ' . base64_encode($API_KEY . ':' . $AUTH_TOKEN),
                // );

		        $ch = curl_init();
		        curl_setopt($ch, CURLOPT_URL, $instamojoEndpoint);
		        curl_setopt($ch, CURLOPT_HEADER, false);
		        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		        curl_setopt($ch, CURLOPT_POST, true);
		        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($payload));
		        
		        
		        $response = curl_exec($ch);
		        curl_close($ch);
				// Process the response and send it to the frontend
        		$response = json_decode($response, true);

                
        		//$this->response($response, REST_Controller::HTTP_OK);
        		if(isset($response) && count($response)>0 && isset($response['payment_request']['id']) && $response['payment_request']['id']!=''){

        			
        			//// insert into order tables
        			$orderIdArr = array();
        			$this->load->model('Cart_model');
        			$this->load->model('Order_model');
        			$this->load->model('Transaction_model');
        			if(isset($data['cart_id']) && count($data['cart_id'])>0){
        				foreach ($data['cart_id'] as $ckey => $cvalue) {
        					
        					$cartArr = $this->Cart_model->getCartDetails($cvalue);
        					if(isset($cartArr[0]['id']) && $cartArr[0]['id']!=''){

        						$first_name = (isset($data['first_name']) && $data['first_name']!='') ? $data['first_name'] : '';
        						$last_name = (isset($data['last_name']) && $data['last_name']!='') ? $data['last_name'] : '';
        						$email = (isset($data['email']) && $data['email']!='') ? $data['email'] : '';
        						$phone = (isset($data['phone']) && $data['phone']!='') ? $data['phone'] : '';
        						$user_id = (isset($data['user_id']) && $data['user_id']!='') ? $data['user_id'] : '';
        						$session_key = (isset($data['sessionkey']) && $data['sessionkey']!='') ? $data['sessionkey'] : '';
        						$cart_id = (isset($cartArr[0]['id']) && $cartArr[0]['id']!='') ? $cartArr[0]['id'] : '';
        						$product_id = (isset($cartArr[0]['product_id']) && $cartArr[0]['product_id']!='') ? $cartArr[0]['product_id'] : '';

                                $product_price_id = (isset($cartArr[0]['product_price_id']) && $cartArr[0]['product_price_id']!='') ? $cartArr[0]['product_price_id'] : '';
                                $price_qty = (isset($cartArr[0]['price_qty']) && $cartArr[0]['price_qty']!='') ? $cartArr[0]['price_qty'] : '';
                                $price_unit_name = (isset($cartArr[0]['price_unit_name']) && $cartArr[0]['price_unit_name']!='') ? $cartArr[0]['price_unit_name'] : '';

        						$qty = (isset($cartArr[0]['qty']) && $cartArr[0]['qty']!='') ? $cartArr[0]['qty'] : '';
        						$per_mrp_price = (isset($cartArr[0]['per_mrp_price']) && $cartArr[0]['per_mrp_price']!='') ? $cartArr[0]['per_mrp_price'] : '';
        						$total_mrp_price = (isset($cartArr[0]['total_mrp_price']) && $cartArr[0]['total_mrp_price']!='') ? $cartArr[0]['total_mrp_price'] : '';
        						$per_discount = (isset($cartArr[0]['per_discount']) && $cartArr[0]['per_discount']!='') ? $cartArr[0]['per_discount'] : '';
        						$total_discount = (isset($cartArr[0]['total_discount']) && $cartArr[0]['total_discount']!='') ? $cartArr[0]['total_discount'] : '';

                                $final_per_price = (isset($cartArr[0]['final_per_price']) && $cartArr[0]['final_per_price']!='') ? $cartArr[0]['final_per_price'] : '';
                                $final_total_price = (isset($cartArr[0]['final_total_price']) && $cartArr[0]['final_total_price']!='') ? $cartArr[0]['final_total_price'] : '';

        						$company_name = (isset($data['company_name']) && $data['company_name']!='') ? $data['company_name'] : '';
        						$street1 = (isset($data['street1']) && $data['street1']!='') ? $data['street1'] : '';
        						$street2 = (isset($data['street2']) && $data['street2']!='') ? $data['street2'] : '';
        						$city = (isset($data['city']) && $data['city']!='') ? $data['city'] : '';
        						$state = (isset($data['state']) && $data['state']!='') ? $data['state'] : '';
        						$pincode = (isset($data['pincode']) && $data['pincode']!='') ? $data['pincode'] : '';
        						$order_date = date('Y-m-d H:i:s');
        						$transaction_id = 0;
                                $pay_status = 'PENDING';
        						$order_status = 'PENDING';

        						$orderArr = array(
        										'first_name' => $first_name,
        										'last_name' => $last_name,
        										'email' => $email,
        										'phone' => $phone,
        										'user_id' => $user_id,
        										'session_key' => $session_key,
        										'cart_id' => $cart_id,
        										'product_id' => $product_id,
                                                'product_price_id' => $product_price_id,
                                                'price_qty' => $price_qty,
                                                'price_unit_name' => $price_unit_name,
        										'qty' => $qty,
        										'per_mrp_price' => $per_mrp_price,
        										'total_mrp_price' => $total_mrp_price,
        										'per_discount' => $per_discount,
        										'total_discount' => $total_discount,
                                                'final_per_price' => $final_per_price,
                                                'final_total_price' => $final_total_price,
        										'company_name' => $company_name,
        										'street1' => $street1,
        										'street2' => $street2,
        										'city' => $city,
        										'state' => $state,
        										'pincode' => $pincode,
        										'order_date' => $order_date,
        										'transaction_id' => $transaction_id,
                                                'pay_status' => $pay_status,
        										'order_status' => $order_status,
        									);
        						$yy = $this->Order_model->insertOrder($orderArr);
        						
        						if($yy!=false && $yy>0){
        							$orderIdArr[] = $yy;
        							/// Update Cart Table	
        							$cDataArr = array('status'=>'MOVETOORDER');
        							$this->Cart_model->updateCart($cart_id,$cDataArr);
        						}
        					}
        				}
        				//// insert into transaction tables
        				if(isset($orderIdArr) && count($orderIdArr)>0){

        					$user_id = (isset($data['user_id']) && $data['user_id']!='') ? $data['user_id'] : '';
        					$session_key = (isset($data['sessionkey']) && $data['sessionkey']!='') ? $data['sessionkey'] : '';
        					$order_id = implode(',',$orderIdArr);

        					$payment_request_id = (isset($response['payment_request']['id']) && $response['payment_request']['id']!='') ? $response['payment_request']['id'] : '';

        					$phone = (isset($response['payment_request']['phone']) && $response['payment_request']['phone']!='') ? $response['payment_request']['phone'] : '';
        					$email = (isset($response['payment_request']['email']) && $response['payment_request']['email']!='') ? $response['payment_request']['email'] : '';
        					$buyer_name = (isset($response['payment_request']['buyer_name']) && $response['payment_request']['buyer_name']!='') ? $response['payment_request']['buyer_name'] : '';
        					$amount = (isset($response['payment_request']['amount']) && $response['payment_request']['amount']!='') ? $response['payment_request']['amount'] : '';
        					$purpose = (isset($response['payment_request']['purpose']) && $response['payment_request']['purpose']!='') ? $response['payment_request']['purpose'] : '';
        					$expires_at = (isset($response['payment_request']['expires_at']) && $response['payment_request']['expires_at']!='') ? $response['payment_request']['expires_at'] : '';
        					$status = (isset($response['payment_request']['status']) && $response['payment_request']['status']!='') ? $response['payment_request']['status'] : '';
        					$send_sms = (isset($response['payment_request']['send_sms']) && $response['payment_request']['send_sms']!='') ? $response['payment_request']['send_sms'] : '';
        					$send_email = (isset($response['payment_request']['send_email']) && $response['payment_request']['send_email']!='') ? $response['payment_request']['send_email'] : '';
        					$sms_status = (isset($response['payment_request']['sms_status']) && $response['payment_request']['sms_status']!='') ? $response['payment_request']['sms_status'] : '';
        					$email_status = (isset($response['payment_request']['email_status']) && $response['payment_request']['email_status']!='') ? $response['payment_request']['email_status'] : '';
        					$shorturl = (isset($response['payment_request']['shorturl']) && $response['payment_request']['shorturl']!='') ? $response['payment_request']['shorturl'] : '';
        					$longurl = (isset($response['payment_request']['longurl']) && $response['payment_request']['longurl']!='') ? $response['payment_request']['longurl'] : '';
        					$redirect_url = (isset($response['payment_request']['redirect_url']) && $response['payment_request']['redirect_url']!='') ? $response['payment_request']['redirect_url'] : '';
        					$webhook = (isset($response['payment_request']['webhook']) && $response['payment_request']['webhook']!='') ? $response['payment_request']['webhook'] : '';
        					$allow_repeated_payments = (isset($response['payment_request']['allow_repeated_payments']) && $response['payment_request']['allow_repeated_payments']!='') ? $response['payment_request']['allow_repeated_payments'] : '';

        					$created_at = (isset($response['payment_request']['created_at']) && $response['payment_request']['created_at']!='') ? $response['payment_request']['created_at'] : '';
        					// Create a DateTime object from the ISO datetime string
							$datetime_created_at = new DateTime($created_at);
							// Convert the DateTime object to MySQL datetime format
							$created_at = $datetime_created_at->format('Y-m-d H:i:s');

        					
        					$modified_at = (isset($response['payment_request']['modified_at']) && $response['payment_request']['modified_at']!='') ? $response['payment_request']['modified_at'] : '';

        					// Create a DateTime object from the ISO datetime string
							$datetime_modified_at = new DateTime($modified_at);
							// Convert the DateTime object to MySQL datetime format
							$modified_at = $datetime_modified_at->format('Y-m-d H:i:s');

        					$payment_id = (isset($response['payment_request']['payment_id']) && $response['payment_request']['payment_id']!='') ? $response['payment_request']['payment_id'] : '';
        					$payment_status = '';
        					$pay_status = 'PENDING';

        					$transactionArr = array(
        										'user_id' => $user_id,
        										'session_key' => $session_key,
        										'order_id' => $order_id,
        										'payment_request_id' => $payment_request_id,
        										'phone' => $phone,
        										'email' => $email,
        										'buyer_name' => $buyer_name,
        										'amount' => $amount,
        										'purpose' => $purpose,
        										'expires_at' => $expires_at,
        										'status' => $status,
        										'send_sms' => $send_sms,
        										'send_email' => $send_email,
        										'sms_status' => $sms_status,
        										'email_status' => $email_status,
        										'shorturl' => $shorturl,
        										'longurl' => $longurl,
        										'redirect_url' => $redirect_url,
        										'webhook' => $webhook,
        										'allow_repeated_payments' => $allow_repeated_payments,
        										'created_at' => $created_at,
        										'modified_at' => $modified_at,
        										'payment_id' => $payment_id,
        										'payment_status' => $payment_status,
        										'pay_status' => $pay_status,
        									);
        					$xx = $this->Transaction_model->insertTransactions($transactionArr);
        					if($xx!=false && $xx>0){
        						// update transaction id in order table
        						foreach ($orderIdArr as $okey => $ovalue) {
        							$oDataArr = array('transaction_id'=>$xx);
        							$this->Order_model->updateOrder($ovalue,$oDataArr);
        						}

        						$this->response(array('status'=>true,"message"=>"Success.","code"=>200,"data"=>$response), REST_Controller::HTTP_OK);

        					}else{
        						$this->response(array('status'=>false,"message"=>"Something is wrong in transaction, try again after sometimes.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);	
        					}
        				}else{
        					$this->response(array('status'=>false,"message"=>"Order not inserted.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
        				}
        			}else{
        				$this->response(array('status'=>false,"message"=>"Cart data not found.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
        			}
        		}else{
        			$this->response(array('status'=>false,"message"=>"We could not reach the payment gateway.","code"=>401,"data"=>$response), REST_Controller::HTTP_OK);	
        		}
            }else{
             	$this->response(array('status'=>false,"message"=>"Session Key Mismatch.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
            }

		}else{

			$this->response(array('status'=>false,"message"=>"Requested data are missing.","code"=>404,"data"=>null), REST_Controller::HTTP_OK);
		}
		
	}				
}
?>