<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: *");
// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;



class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);


		if(isset($data['payment_id']) && $data['payment_id']!='' && isset($data['payment_status']) && $data['payment_status']!='' && isset($data['payment_request_id']) && $data['payment_request_id']!='' && isset($data['user_id']) && $data['user_id']!='' && isset($data['sessionkey']) && $data['sessionkey']!=''){


			$this->load->model('Authenticationcheck');
			$checkSessionKey = $this->Authenticationcheck->validateSessionKey($data['sessionkey'],$data['user_id']);

			
            if($checkSessionKey==true){
                
                //// insert into order tables
    			$orderIdArr = array();
    			$this->load->model('Order_model');
    			$this->load->model('Transaction_model');
    			$this->load->model('Profile_model');

				//// update into transaction tables
				$user_id = (isset($data['user_id']) && $data['user_id']!='') ? $data['user_id'] : '';
				$session_key = (isset($data['sessionkey']) && $data['sessionkey']!='') ? $data['sessionkey'] : '';
                $payment_id = (isset($data['payment_id']) && $data['payment_id']!='') ? $data['payment_id'] : '';
                $payment_status = (isset($data['payment_status']) && $data['payment_status']!='') ? $data['payment_status'] : '';
                $payment_request_id = (isset($data['payment_request_id']) && $data['payment_request_id']!='') ? $data['payment_request_id'] : '';
				
				$userDetailsArr = $this->Profile_model->getProfileDetails($user_id);
				$userEmail = (isset($userDetailsArr[0]['email']) && $userDetailsArr[0]['email']!='') ? $userDetailsArr[0]['email'] : '';
				$userFullName = (isset($userDetailsArr[0]['fullname']) && $userDetailsArr[0]['fullname']!='') ? $userDetailsArr[0]['fullname'] : '';

                $pay_status = 'FAILED';
                $order_pay_status = 'ERROR';
                $order_status = 'REJECTED';

                if($payment_status=='Credit'){
                    $pay_status = 'SUCCESS';
                    $order_pay_status = 'SUCCESS';
                    $order_status = 'ACCEPTED';
                }
				$transactionArr = array(
									'payment_id' => $payment_id,
									'payment_status' => $payment_status,
									'pay_status' => $pay_status
								);
				$xx = $this->Transaction_model->updateTransaction($user_id,$session_key,$payment_request_id,$transactionArr);
				if($xx!=false){
					// get transaction details
					$transactionDetailsArr = $this->Transaction_model->getTransactionDetails($user_id,$session_key,$payment_request_id);
                    $orderaIdArr = (isset($transactionDetailsArr[0]['order_id']) && $transactionDetailsArr[0]['order_id']!='') ? explode(',', $transactionDetailsArr[0]['order_id']) : array();
                    $statusUpdated = false;
                    if(isset($orderaIdArr) && count($orderaIdArr)>0){
                        foreach ($orderaIdArr as $okey => $ovalue) {
                            
                            $orderDataArr = array('pay_status'=>$order_pay_status,'order_status'=>$order_status);
                            $yy = $this->Order_model->updateOrder($ovalue,$orderDataArr);
                            if($yy!=false){
                                $statusUpdated = true;
                            }
                        }
                    }

                    if($statusUpdated==true){
                    	if($pay_status=='SUCCESS'){

                    		
							$html=<<<EOT
							Dear {$userFullName},<br/>
							<p>Thank you for making purchase at Liebigs Agro Chem Pvt Ltd. Your order has been received. Your payment transaction id is {$payment_id}.</p>
							<p>Your order will be dispatched soon.</p>
							<p><a href="https://liebigsagrochem.com/">Click here to Keep Shopping</a></p>
EOT;
                    		$emailSubject = 'Thank You For Your Order - Liebigs';
                    		$this->response(array('status'=>true,"message"=>"Thank you. You have successfully paid","code"=>200,"data"=>null), REST_Controller::HTTP_OK);
                    	}else{
                    		$html=<<<EOT
							Dear {$userFullName},<br/>
							<p>Sorry! We couldn't process your order. Your order with Liebigs Agro Chem Pvt Ltd is failed. </p>
							<p>We request you to create a new purchase.</p>
							<p><a href="https://liebigsagrochem.com/">Shop Now</a></p>
EOT;
                    		$emailSubject = 'Order Failed - Liebigs';
                    		$this->response(array('status'=>false,"message"=>"Your payment is failed.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
                    	}

                    	// start email
                    	$this->load->library('email');
						$config['protocol']    = 'ssl';//'mail';
						$config['smtp_host']    = 'smtp.gmail.com';//'webmail.digitalwolf.co.in';
						$config['smtp_port']    = '465';//'25';
						$config['smtp_timeout'] = '7';
						$config['smtp_user']    = 'orderonline@liebigsagrochem.com';
						$config['smtp_pass']    = '4321@ccps$';
						$config['charset']    = 'utf-8';
						$config['newline']    = "\r\n";
						$config['mailtype'] = 'text'; // or html
						$config['validation'] = TRUE; // bool whether to validate email or not            

						$this->email->initialize($config);

						$to = $userEmail;
						$from = 'orderonline@liebigsagrochem.com';

						$this->email->from($from, 'Liebigs');
						$this->email->to($to);

						//$ccArr = array('xxxxxxx');
						//$this->email->cc($ccArr);
						//$this->email->bcc('xxxxxx');

						$this->email->subject($emailSubject);
						$this->email->message($html);


						//$filePath = $_SERVER['DOCUMENT_ROOT'].'/assets/clientsfile';

						//$frstFile = $filePath.'/xxxxxxxxxxx.pdf';
						//$sndFile = $filePath.'/xxxxxxxxx.jpg';
						//$this->email->attach($frstFile);
						//$this->email->attach($sndFile);
						$this->email->set_mailtype("html");
						$this->email->send();
						$this->email->clear(TRUE);
						/////////////////End email
                        
                    }else{
                        $this->response(array('status'=>false,"message"=>"Something is wrong in transaction updated, try again after sometimes.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);    
                    }
					

				}else{
					$this->response(array('status'=>false,"message"=>"Something is wrong in transaction updated, try again after sometimes.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);	
				}
            }else{
             	$this->response(array('status'=>false,"message"=>"Session Key Mismatch.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
            }

		}else{

			$this->response(array('status'=>false,"message"=>"Requested data are missing.","code"=>404,"data"=>null), REST_Controller::HTTP_OK);
		}
		
	}				
}
?>