<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;

class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	//if (!function_exists('getallheaders')) {
		private function getallheaders() {
	    	$headers = [];
	    	//var_dump($_SERVER);
	    	foreach ($_SERVER as $name => $value) {
	        	if (substr($name, 0, 5) == 'HTTP_') {
	            	$headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
	        	}
	    	}
	    	//var_dump($headers);

	    	return $headers;
	    }
	//}

		private function get_nginx_headers($function_name='getallheaders'){

	        $all_headers=array();

	        if(function_exists($function_name)){ 

	            $all_headers=$function_name();
	        }
	        else{

	            foreach($_SERVER as $name => $value){

	                if(substr($name,0,5)=='HTTP_'){

	                    $name=substr($name,5);
	                    $name=str_replace('_',' ',$name);
	                    $name=strtolower($name);
	                    $name=ucwords($name);
	                    $name=str_replace(' ', '-', $name);

	                    $all_headers[$name] = $value; 
	                }
	                elseif($function_name=='apache_request_headers'){

	                    $all_headers[$name] = $value; 
	                }
	            }
	        }


	        return $all_headers;
	}
	
	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed.","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);

		
		if(isset($data['product_id']) && $data['product_id']!=''){	

			$this->load->model('Products_model');
			$productArr = $this->Products_model->getProductDetails($data['product_id']);

			$resultArr = array();
			if(isset($productArr) && count($productArr)>0){
				foreach ($productArr as $pkey => $pvalue) {
					//if($pvalue['id']!=46) continue;

					$pPArr = $this->Products_model->getProductPrices($pvalue['id']);
					$pPricesArr = array();
					if(isset($pPArr) && count($pPArr)>0){
						foreach ($pPArr as $ppkey => $ppvalue) {
							
							$pPricesArr[$ppkey]['product_price_id'] = $ppvalue['id'];
							$pPricesArr[$ppkey]['qty'] = round($ppvalue['qty']);
							$pPricesArr[$ppkey]['unit_id'] = $ppvalue['unit_id'];
							$pPricesArr[$ppkey]['unit_name'] = $ppvalue['unit_name'];
							$pPricesArr[$ppkey]['mrp'] = $ppvalue['mrp'];
							$pPricesArr[$ppkey]['discount'] = $ppvalue['discount'];
							$pPricesArr[$ppkey]['final_price'] = $ppvalue['final_price'];
							
						}
					}

					$pImageArr = $this->Products_model->getProductImageAll($pvalue['id']);
					$pimageArr = array();
					if(isset($pImageArr) && count($pImageArr)>0){
						foreach ($pImageArr as $pikey => $pivalue) {
							
							if(isset($pivalue['image']) && $pivalue['image']!=''){
								$pimage = 'https://liebigs.hitechanimation.com/backend/assets/productimages/'.$pivalue['image'];
								$pimageArr[] = $pimage;
							}
							
						}
					}
					
					$pArr = array(
								'id' => $pvalue['id'],
								'categorykey' => $pvalue['categorykey'],
								'category' => $pvalue['category'],
								'product_code' => $pvalue['product_code'],
								'product_name' => $pvalue['product_name'],
								//'product_price' => $pvalue['product_price'],
								//'discount_price' => $pvalue['discount_price'],
								'sku_number' => $pvalue['sku_number'],
								'product_description' => $pvalue['product_description'],
								'in_stock' => $pvalue['in_stock'],
								'images' => $pimageArr,
								'prices' => $pPricesArr
							);
					$resultArr[] = $pArr;
				}
			}

			if(isset($resultArr) && $resultArr>0){

				$this->response(array("status"=>true,"message"=>"Successfully load product details","data"=>$resultArr,"code"=>200),REST_Controller::HTTP_OK);

			}else{
				$this->response(array('status'=>false,"message"=>"Something Wrong, Please contact to system admin.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);	
			}		

		}else{
			$this->response(array('status'=>false,"message"=>"Requested Dataset Missing.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
		}		
		
	}				
}
?>