<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;

class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	//if (!function_exists('getallheaders')) {
		private function getallheaders() {
	    	$headers = [];
	    	//var_dump($_SERVER);
	    	foreach ($_SERVER as $name => $value) {
	        	if (substr($name, 0, 5) == 'HTTP_') {
	            	$headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
	        	}
	    	}
	    	//var_dump($headers);

	    	return $headers;
	    }
	//}

		private function get_nginx_headers($function_name='getallheaders'){

	        $all_headers=array();

	        if(function_exists($function_name)){ 

	            $all_headers=$function_name();
	        }
	        else{

	            foreach($_SERVER as $name => $value){

	                if(substr($name,0,5)=='HTTP_'){

	                    $name=substr($name,5);
	                    $name=str_replace('_',' ',$name);
	                    $name=strtolower($name);
	                    $name=ucwords($name);
	                    $name=str_replace(' ', '-', $name);

	                    $all_headers[$name] = $value; 
	                }
	                elseif($function_name=='apache_request_headers'){

	                    $all_headers[$name] = $value; 
	                }
	            }
	        }


	        return $all_headers;
	}
	
	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed.","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);

		
		if(isset($data['categorykey']) && $data['categorykey']!=''){	

			$this->load->model('Products_model');
			$categoryArr = $this->Products_model->getProductCategoryDetails($data['categorykey']);

			if(isset($categoryArr) && count($categoryArr)>0){
				foreach ($categoryArr as $ckey => $cvalue) {
					
					$productArr = $this->Products_model->getProductList($cvalue['id']);

					$resultArr = array();
					if(isset($productArr) && count($productArr)>0){
						foreach ($productArr as $pkey => $pvalue) {
							//if($pvalue['id']!=46) continue;

							$pPriceArr = $this->Products_model->getProductPrices($pvalue['id']);
							$product_price_id = (isset($pPriceArr[0]['id']) && $pPriceArr[0]['id']!='') ? $pPriceArr[0]['id'] : 0;
							$price_qty = (isset($pPriceArr[0]['qty']) && $pPriceArr[0]['qty']!='') ? $pPriceArr[0]['qty'] : 0;
							$price_unit_name = (isset($pPriceArr[0]['unit_name']) && $pPriceArr[0]['unit_name']!='') ? $pPriceArr[0]['unit_name'] : '';
							$price_mrp = (isset($pPriceArr[0]['mrp']) && $pPriceArr[0]['mrp']!='') ? $pPriceArr[0]['mrp'] : 0;
							$price_discount = (isset($pPriceArr[0]['discount']) && $pPriceArr[0]['discount']!='') ? $pPriceArr[0]['discount'] : 0;
							$price_final_price = (isset($pPriceArr[0]['final_price']) && $pPriceArr[0]['final_price']!='') ? $pPriceArr[0]['final_price'] : 0;


							$products_units_all = '';
							if(isset($pPriceArr) && count($pPriceArr)>0){
								$i=1;
								foreach ($pPriceArr as $pukey => $puvalue) {
									
									if($i==count($pPriceArr)){
										$products_units_all.= round($puvalue['qty']).' '.$puvalue['unit_name'];
									}else{
										$products_units_all.= round($puvalue['qty']).' '.$puvalue['unit_name'].', ';
									}
								$i++;}
							}else{
								$products_units_all = 'NA';
							}
							
							$pImageArr = $this->Products_model->getProductImage($pvalue['id']);
							$pimage = '';
							if(isset($pImageArr[0]['image']) && $pImageArr[0]['image']!=''){
								$pimage = 'https://liebigs.hitechanimation.com/backend/assets/productimages/'.$pImageArr[0]['image'];
							}
							$pArr = array(
										'id' => $pvalue['id'],
										'category' => $pvalue['category'],
										'product_code' => $pvalue['product_code'],
										'product_name' => $pvalue['product_name'],
										//'product_price' => $pvalue['product_price'],
										//'discount_price' => $pvalue['discount_price'],
										'sku_number' => $pvalue['sku_number'],
										//'product_description' => $pvalue['product_description'],
										'in_stock' => $pvalue['in_stock'],
										'image' => $pimage,
										'product_price_id' => $product_price_id,
										'price_qty' => round($price_qty),
										'price_unit_name' => $price_unit_name,
										'price_mrp' => $price_mrp,
										'price_discount' => $price_discount,
										'price_final_price' => $price_final_price,
										'products_units_all' => $products_units_all
									);
							$resultArr[] = $pArr;
						}
					}
				}
			}

			if(isset($resultArr) && $resultArr>0){

				$this->response(array("status"=>true,"message"=>"successfully load product list","data"=>$resultArr,"code"=>200),REST_Controller::HTTP_OK);

			}else{
				$this->response(array('status'=>false,"message"=>"Something Wrong, Please contact to system admin.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);	
			}		

		}else{
			$this->response(array('status'=>false,"message"=>"Requested Dataset Missing.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
		}		
		
	}				
}
?>