<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: *");

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;

class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	//if (!function_exists('getallheaders')) {
		private function getallheaders() {
	    	$headers = [];
	    	//var_dump($_SERVER);
	    	foreach ($_SERVER as $name => $value) {
	        	if (substr($name, 0, 5) == 'HTTP_') {
	            	$headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
	        	}
	    	}
	    	//var_dump($headers);

	    	return $headers;
	    }
	//}

		private function get_nginx_headers($function_name='getallheaders'){

	        $all_headers=array();

	        if(function_exists($function_name)){ 

	            $all_headers=$function_name();
	        }
	        else{

	            foreach($_SERVER as $name => $value){

	                if(substr($name,0,5)=='HTTP_'){

	                    $name=substr($name,5);
	                    $name=str_replace('_',' ',$name);
	                    $name=strtolower($name);
	                    $name=ucwords($name);
	                    $name=str_replace(' ', '-', $name);

	                    $all_headers[$name] = $value; 
	                }
	                elseif($function_name=='apache_request_headers'){

	                    $all_headers[$name] = $value; 
	                }
	            }
	        }


	        return $all_headers;
	}
	
	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed.","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);

		
		if(isset($data['user_id']) && $data['user_id']!='' && isset($data['sessionkey']) && $data['sessionkey']!='' && isset($data['currentpassword']) && $data['currentpassword']!='' && isset($data['newpassword']) && $data['newpassword']!=''){	
			$this->load->model('Authenticationcheck');
			$checkSessionKey = $this->Authenticationcheck->validateSessionKey($data['sessionkey'],$data['user_id']);

			if($checkSessionKey==true){

				$user_id = (isset($data['user_id']) && $data['user_id']!='') ? $data['user_id'] : 0;
				$session_key = (isset($data['sessionkey']) && $data['sessionkey']!='') ? $data['sessionkey'] : '';
				$currentpassword = (isset($data['currentpassword']) && $data['currentpassword']!='') ? $data['currentpassword'] : '';
				$newpassword = (isset($data['newpassword']) && $data['newpassword']!='') ? $data['newpassword'] : '';

				$this->load->model('Profile_model');
				$uArr = $this->Profile_model->getProfilePasswordValid($user_id,md5($currentpassword));
				if(isset($uArr) && count($uArr)){

					
					$dataArr = array(
								'password' => md5($newpassword)
							);
					$xx = $this->Profile_model->updateProfile($user_id,$dataArr);
					if($xx==true){
						$this->response(array('status'=>true,"message"=>"Password updated successfully!","code"=>200,"data"=>null), REST_Controller::HTTP_OK);
					}else{
						$this->response(array('status'=>false,"message"=>"Something wrong try again after sometime.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
					}
				}else{

					$this->response(array('status'=>false,"message"=>"Current passwod does not matched.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
					
				}		
			}else{
				$this->response(array('status'=>false,"message"=>"Session Key Mismatch.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
			}
		}else{
			$this->response(array('status'=>false,"message"=>"Requested Dataset Missing.","code"=>403,"data"=>null), REST_Controller::HTTP_OK);
		}		
		
	}				
}
?>