<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;

class V1 extends REST_Controller{

	function __construct(){	

		parent::__construct();	

		date_default_timezone_set('Asia/Kolkata');
		// Configure limits on our controller methods
	    // Ensure you have created the 'limits' table and enabled 'limits' within application/config/rest.php
	    $this->methods['users_get']['limit'] = 500; // 500 requests per hour per user/key
	    $this->methods['users_post']['limit'] = 100; // 100 requests per hour per user/key
	    $this->methods['users_delete']['limit'] = 50; // 50 requests per hour per user/key

	}

	public function index_get(){
		
		$this->response(array('status'=>false,'message'=>"GET Method Not Allowed","code"=>"401","data"=>null), REST_Controller::HTTP_BAD_REQUEST);
	}

	public function index_post(){

		$data = json_decode(file_get_contents('php://input'), true);


		if(isset($data['email']) && $data['email']!='' && isset($data['password']) && $data['password']!=''){


			$this->load->model('Authenticationcheck');
			$xx = $this->Authenticationcheck->validateUser($data['email'],$data['password']);

			//if(count($xx)>0){
            if(is_object($xx)){
                
				$this->response(array('status'=>false,"message"=>"Email Already Exists!.","code"=>404,"data"=>null), REST_Controller::HTTP_OK);
				

             }else{
             	
             	$fullname = isset($data['fullname']) ? $data['fullname'] : '';
             	$email = isset($data['email']) ? $data['email'] : '';
             	$phonenumber = isset($data['phonenumber']) ? $data['phonenumber'] : '';
             	$password = isset($data['password']) ? md5($data['password']) : '';
             	$created_on = date('Y-m-d H:i:s');
				$status = 'ACTIVE';

				$dataArr = array(
								'fullname'=> $fullname,
								'email'=> $email,
								'phonenumber'=> $phonenumber,
								'password'=> $password,
								'created_on'=> $created_on,
								'status'=> $status
							);

				$insertId = $this->Authenticationcheck->insertUsers($dataArr);


				if($insertId>0 && $insertId!=false){

					
					// Start Email
					$clientName = $fullname;
					$html=<<<EOT
					Dear {$clientName},<br/>
					<p>Your account with Liebigs Agro Chem Pvt Ltd is successfully created. Thank you for registration. Enjoy Liebigs products and services.</p>
					<p><a href="https://liebigsagrochem.com">Shop Now</a></p>
EOT;

					$this->load->library('email');

					$config['protocol']    = 'ssl';//'mail';
					$config['smtp_host']    = 'smtp.gmail.com';//'webmail.digitalwolf.co.in';
					$config['smtp_port']    = '465';//'25';
					$config['smtp_timeout'] = '7';
					$config['smtp_user']    = 'orderonline@liebigsagrochem.com';
					$config['smtp_pass']    = '4321@ccps$';
					$config['charset']    = 'utf-8';
					$config['newline']    = "\r\n";
					$config['mailtype'] = 'text'; // or html
					$config['validation'] = TRUE; // bool whether to validate email or not            

					$this->email->initialize($config);

					$to = $email;
					$from = 'orderonline@liebigsagrochem.com';

					$this->email->from($from, 'Liebigs');
					$this->email->to($to);

					//$ccArr = array('xxxxxxx');
					//$this->email->cc($ccArr);
					//$this->email->bcc('xxxxxx');

					$this->email->subject('Registration Successful - Liebigs');
					$this->email->message($html);


					//$filePath = $_SERVER['DOCUMENT_ROOT'].'/assets/clientsfile';

					//$frstFile = $filePath.'/xxxxxxxxxxx.pdf';
					//$sndFile = $filePath.'/xxxxxxxxx.jpg';
					//$this->email->attach($frstFile);
					//$this->email->attach($sndFile);
					$this->email->set_mailtype("html");
					$this->email->send();
					$this->email->clear(TRUE);
					/////////////////End email
					$this->response(array("status"=>true,"message"=>"You have successfully registered. Please wait we are redirecting to login.","data"=>null,"code"=>200),REST_Controller::HTTP_OK);
				}else{
					$this->response(array('status'=>false,"message"=>"Something wrong, Please contact to system admin.","code"=>401,"data"=>null), REST_Controller::HTTP_OK);
				}
             }

		}else{

			$this->response(array('status'=>false,"message"=>"Email or Password Not Found.","code"=>404,"data"=>null), REST_Controller::HTTP_OK);
		}
		
	}				
}
?>