<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set("Asia/Kolkata");
class Units extends CI_Controller {

	function __construct()
	{

		parent::__construct();

		$checkuservars = $this->session->userdata;
                
        if((!isset($checkuservars['usertype']) || $checkuservars['usertype']!="SUPERADMIN") && (!isset($checkuservars['usertype']) || $checkuservars['usertype']!="ADMIN")){
        	redirect('login/logout/'); 
        }	
	}

	public function lists()
	{
		$data = array();
		
		$this->load->model('Units_management');
		$data['unit_list'] = $this->Units_management->getUnitList();

		
		$this->load->view('unit_list',$data);
	}

	public function add()
	{

		$data = array();
		$this->load->model('Units_management');
		
		if(isset($_POST['unit_name']) && $_POST['unit_name']!=''){
			
			
			$unit_name = isset($_POST['unit_name']) ? $_POST['unit_name'] : '';
			$valids_unit = $this->Units_management->unitExists($unit_name);
			if(isset($valids_unit) && count($valids_unit)>0){
				$this->session->set_flashdata('error', 'Unit Already Exists.');
			}else{
				$created_id = $_SESSION['userid'];
				$created_on = date('Y-m-d H:i:s');
				$status = 'ACTIVE';
				
				$unitArr = array(
									'unit_name' => $unit_name,
									'created_id' => $created_id,
									'created_on' => $created_on,
									'status' => $status
								);
				
				$xx = $this->Units_management->insertUnit($unitArr);	
				if($xx>0){
					
					$this->session->set_flashdata('success', 'Unit has been added successfully.');
					redirect('units/lists');

				}else{
					$this->session->set_flashdata('error', 'Something went wrong, Please try again after sometime.');
				}
			}		
			
		}
		

		$this->load->view('unit_add',$data);
	}


	public function edit()
	{

		$data = array();
		$this->load->model('Units_management');
		
		$unitId = $this->uri->segment('3');

		if(isset($_POST['unit_details']) && $_POST['unit_details']!=''){
			
			
			$unit_details = isset($_POST['unit_details']) ? $_POST['unit_details'] : '';			

			$valids_unit = $this->Units_management->unit_edit($unitId,$unit_details);
			
			if(isset($valids_unit) && count($valids_unit)>0){
				$this->session->set_flashdata('error', 'Unit Already Exists.');
			}else{
				
				$unitArr = array(
									'unit_name' => $unit_name
								);
				
				$xx = $this->Units_management->updateUnit($unitId,$unitArr);	
				if($xx==true){
					
					$this->session->set_flashdata('success', 'Unit has been updated successfully.');
					redirect('products/cat');

				}else{
					$this->session->set_flashdata('error', 'Something went wrong, Please try again after sometime.');
				}
			}		
			
		}
		
		$data['unit_details'] = $this->Units_management->getUnitDetails($unitId);
		
		$this->load->view('unit_edit',$data);
	}

	public function deleteunit()
	{

		$data = array();
		$this->load->model('Units_management');
		
		$unitId = $this->uri->segment('3');

		if(isset($unitId) && $unitId!=''){

			
				$uData = array(
							'status' => 'DELETED'
						  );
				$this->Units_management->updateUnit($unitId,$uData);

				
				$this->session->set_flashdata('success', 'Unit has been deleted successfully.');
				redirect('units/lists');
	
		}
		
	}
}
