<?php
defined('BASEPATH') OR exit('No direct script access allowed');

include_once('header.php');
?>

<!--== BODY INNER CONTAINER ==-->
<div class="sb2-2">
    <!--== breadcrumbs ==-->
    <div class="sb2-2-2">
        <ul>
            <li><a href="<?php echo base_url('dashboard');?>"><i class="fa fa-home" aria-hidden="true"></i> Home</a>
            </li>
            <li class="active-bre"><a href="#"> Add Product Price</a>
            </li>
            <li class="page-back"><a href="<?php echo base_url('dashboard');?>"><i class="fa fa-backward" aria-hidden="true"></i> Back</a>
            </li>
        </ul>
    </div>

    <!--== User Details ==-->
    <div class="sb2-2-3">
        <div class="row">
            <div class="col-md-12">
			<div class="box-inn-sp admin-form">
                    <div class="inn-title">
                        <h4>New Product Price</h4>
                        
                    </div>
                    <?php if ($this->session->userdata('success')) { ?>
                        <div class="alert alert-success">
                            <?php echo $this->session->userdata('success');?>
                        </div>
                    <?php }?>
                    <?php if ($this->session->userdata('error')) { ?>
                        <div class="alert alert-danger">
                            <?php echo $this->session->userdata('error');?>
                        </div>
                    <?php }?>
                    <div class="bor ad-cou-deta-h4">
                        <form name="frm" action="<?php echo base_url('products/priceadd/'.$this->uri->segment('3'));?>" method="post" enctype='multipart/form-data'>
                            <div class="row">
                                <div class="input-field col s2">
                                    <input type="text" name="qty" value="" class="validate" required>
                                    <label class="">Quantity</label>
                                </div>
                                <div class="input-field col s2">
                                    <select name="unit_id" required="">
                                        <option value="">Select Unit</option>
                                        <?php
                                            if(isset($unit_list) && count($unit_list)>0){
                                                foreach ($unit_list as $ukey => $uvalue) {
                                        ?>
                                        <option value="<?php echo $uvalue['id']?>"><?php echo $uvalue['unit_name']?></option>
                                        <?php }}?>
                                    </select>
                                </div>
                                <div class="input-field col s2">
                                    <input type="text" name="mrp" value="" class="validate mrp-input" required onkeyup="calculateprice(this);">
                                    <label class="">MRP (INR)</label>
                                </div>
                                <div class="input-field col s2">
                                    <input type="text" name="discount" value="" class="validate discount-input" required onkeyup="calculateprice(this);">
                                    <label class="">Discount (INR)</label>
                                </div>
                                <div class="input-field col s2">
                                    <input type="text" name="final_price" value="" class="validate final-price-input" required readonly="">
                                    <label class="">Final Price (INR)</label>
                                </div>
                            </div>
                            <div class="row">
                                <div class="input-field col s12">
                                    <i class="waves-effect waves-light btn-large waves-input-wrapper" style=""><input type="submit" class="waves-button-input"></i>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php include_once('footer.php');?>
<script type="text/javascript">
    function calculateprice(inputElement) {
      // Get the MRP and Discount input elements in the same row
      var row = inputElement.parentElement.parentElement;
      var mrpInput = row.querySelector(".mrp-input");
      var discountInput = row.querySelector(".discount-input");
      var finalPriceInput = row.querySelector(".final-price-input");

      // Parse the values from the input fields
      var mrp = parseFloat(mrpInput.value) || 0;
      var discount = parseFloat(discountInput.value) || 0;

      // Calculate the final price
      var finalPrice = mrp - discount;

      // Update the final price input field
      finalPriceInput.value = finalPrice.toFixed(2); // You can adjust the number of decimal places as needed
    }
</script>